%% Testing process
close all;
clear all;
%% load parameter settings
load ('partLocConfig.mat');
load ('PamaTest');
%% load learned model
load ('learning_result.mat');     
S2Templates = cell(numCluster,1);
for cc = 1:numCluster
    S2Templates{cc} = bestS2Templates{cc};
end
TransformedTemplate = cell(nTransform,numCluster);
selectedScale = zeros(1,length(S2Templates{1}.selectedx),'single');
for cc = 1:numCluster
    for iT = 1:nTransform
        templateScaleInd = templateTransform{iT}(1);
        rowScale = templateTransform{iT}(2);
        colScale = templateTransform{iT}(3);
        rotation = templateTransform{iT}(4);
        [tmpSelectedRow tmpSelectedCol tmpSelectedOri tmpSelectedScale] = ...
            mexc_TemplateAffineTransform( templateScaleInd, rowScale,...
            colScale, rotation, S2Templates{cc}.selectedRow, S2Templates{cc}.selectedCol,...
            S2Templates{cc}.selectedOri, selectedScale, numOrient );
        TransformedTemplate{iT,cc}.selectedRow = tmpSelectedRow;
        TransformedTemplate{iT,cc}.selectedCol = tmpSelectedCol;
        TransformedTemplate{iT,cc}.selectedOri = tmpSelectedOri;
        TransformedTemplate{iT,cc}.selectedScale = tmpSelectedScale;
        TransformedTemplate{iT,cc}.selectedLambda = S2Templates{cc}.selectedLambda;
        TransformedTemplate{iT,cc}.selectedLogZ = S2Templates{cc}.selectedLogZ;
    end
end
% prepare for affinity matrix
templateAffinityMatrix = cell( numCluster * nTransform, 1 );
for cc = 1:numCluster
    from = 1; to = nTransform*numCluster;
    for jj = 1:nTransform
        templateAffinityMatrix{jj+(cc-1)*nTransform} = int32((from:to)-1);
    end
end
%% calculate SUM1MAX1
for all_I_c=3:length(all_I_n)
    test_SUM1MAX1;
end;
all_W_n=dir(all_W_fold);
%% decoding process
Stepsize=2;
Halfwinsize=1;
SE=ones(2*Halfwinsize+1,2*Halfwinsize+1);
for all_W_c=3:length(all_W_n)
    sub_sum1max1_file=[all_W_fold '/' all_W_n(all_W_c).name];
    file_name=dir([sub_sum1max1_file  '/SUM1MAX1map'  '*.mat']);
    L0_data=[];
    L1_data=[];
    L2_data=[];
    for file_i=1:length(file_name)
        SUM1MAX1mapName = [sub_sum1max1_file '/' file_name(file_i).name];
        disp(['decoding image' num2str(file_i)]);
        load(SUM1MAX1mapName, 'SUM1map', 'MAX1map', 'M1RowShift', 'M1ColShift',...
                'M1OriShifted', 'J');
        NumsmpX=zeros(numResolution,1);
        NumsmpY=zeros(numResolution,1);
        for iRes = 1:numResolution
            SUM2map(:,iRes) = mexc_ComputeSUM2( numOrient, MAX1map(iRes,:), TransformedTemplate, subsampleS2 );
            Nowhws = Halfwinsize*allResolution(iRes);
            Nowsps = Stepsize*allResolution(iRes);
            NumsmpX(iRes)=floor((size(SUM2map{1,iRes},1)-2*Nowhws-1)/Nowsps)+1;
            NumsmpY(iRes)=floor((size(SUM2map{1,iRes},2)-2*Nowhws-1)/Nowsps)+1;
        end;
        % exclude the near-boundary region
        for ii = 1:numel(SUM2map)
            SUM2map{ii}(:,[1:floor(templateSize(2)/2) end-floor(templateSize(2)/2):end]) = min(-1001,S2Thres-1);
            SUM2map{ii}([1:floor(templateSize(1)/2) end-floor(templateSize(1)/2):end],:) = min(-1001,S2Thres-1);
        end
        MINnumX=min(NumsmpX);
        MINnumY=min(NumsmpY);
        POSx=zeros(MINnumX,1);
        POSy=zeros(1,MINnumY);
        posIND=cell(iRes,1);
        sizeI=MINnumX*MINnumY;
        tmpPXV=zeros(MINnumX*MINnumY,1);
        tmpPYV=zeros(MINnumX*MINnumY,1);
        for iRes = 1:numResolution
            Nowhws = Halfwinsize*allResolution(iRes);
            Nowsps = Stepsize*allResolution(iRes);
            POSx = round(((1:MINnumX)'-1)*Nowsps+Nowhws +1);
            POSy = round(((1:MINnumY)-1)*Nowsps+Nowhws +1);
            tmpPXV=reshape(repmat(POSx,1,length(POSy)),sizeI,1);
            tmpPYV=reshape(repmat(POSy,length(POSx),1),sizeI,1);
            posIND{iRes}=sub2ind(size(SUM2map{1,iRes}), tmpPXV, tmpPYV);
        end;
        tmpMAXSUM2=cell(numel(SUM2map(:,1)),numResolution);
        sumSUM2=zeros(MINnumX,MINnumY);
        for ii = 1:numel(SUM2map(:,1))
            for iRes = 1:numResolution
                tmpMAXSUM2{ii,iRes}=zeros(MINnumX,MINnumY);
                lcMax=imdilate(SUM2map{ii,iRes},SE);
                tmpMAXSUM2{ii,iRes}=reshape(lcMax(posIND{iRes}), MINnumX, MINnumY);
            end;
        end;
        tmpActivations = mexc_ComputeMAX2MP( SUM2map, int32(locationPerturbationFraction*partSize/subsampleS2), -1000 );
        iCluster = ceil( ( tmpActivations(4,:) + 1 ) / nTransform );
        hv=hist(iCluster,1:numCluster);
        L0_positive_sum=[];
        L1_positive_sum=[];
        L2_positive_sum=[];
        for ii = 1:numel(SUM2map(:,iRes))
            tmpMax=[];
            for iRes=1:numResolution
                CC=tmpMAXSUM2{ii,iRes};
                [CCx CCy]=size(CC);
                t1=max(max( CC ));
                t2=max(max( CC(1:ceil(CCx/2), 1:ceil(CCy/2)) ));
                t3=max(max( CC(1+ceil(CCx/2):end, 1:ceil(CCy/2)) ));
                t4=max(max( CC(1:ceil(CCx/2), 1+ceil(CCy/2):CCy) ));
                t5=max(max( CC(1+ceil(CCx/2):end, 1+ceil(CCy/2):CCy) )); 
                t=[t1 t2 t3 t4 t5];
                for m=1:3
                    for n=1:3
                        t=[t max(max(CC(ceil((m-1)/3*CCx+1):ceil(m/3*CCx), ceil((n-1)/3*CCy+1):ceil(n/3*CCy))))];
                    end;
                end;
                tmpMax = [tmpMax; t];
            end;
            tmpV=max(tmpMax);
            Vind=find(tmpV<0);
            tmpV(Vind)=0;
            L0_positive_sum=[L0_positive_sum tmpV(1:1)];
            L1_positive_sum=[L1_positive_sum tmpV(1:5)];
            L2_positive_sum=[L2_positive_sum tmpV];
        end;
        L0_data=[L0_data; L0_positive_sum];
        L1_data=[L1_data; L1_positive_sum];
        L2_data=[L2_data; L2_positive_sum];
    end;
    save ([all_S_fold '/'  all_W_n(all_W_c).name 'Score'],'L0_data','L1_data','L2_data');
end;
    %----------------------------------------------------------------------
    
    %L0_positive_data=[];
    %L1_positive_data=[];
    %L2_positive_data=[];
    %for file_i=1:length(file_name)
    %    SUM1MAX1mapName = [sub_sum1max1_file '/' file_name(file_i).name];
    %    disp(['decoding image' num2str(file_i)]);
    %    load(SUM1MAX1mapName, 'SUM1map', 'MAX1map', 'M1RowShift', 'M1ColShift',...
    %            'M1OriShifted', 'J');
    %    for iRes = 1:numResolution
    %        SUM2map(:,iRes) = mexc_ComputeSUM2( numOrient, MAX1map(iRes,:), TransformedTemplate, subsampleS2 );
    %    end
    %    %SUM2map = mexc_ComputeSUM2( numOrient, MAX1map, TransformedTemplate, subsampleS2 );
    %    % random perturbation (to break ties arbitrarily for MAX2)
    %    L0_positive_sum=[];
    %    L1_positive_sum=[];
    %    L2_positive_sum=[];
        %tmpActivations=[];
    %    for ii = 1:numel(SUM2map(:,iRes))
    %        tmp_max=[];
    %        for iRes=1:numResolution
    %            SUM2map{ii,iRes}(:) = SUM2map{ii,iRes}(:) + 1e-3 * ( rand(numel(SUM2map{ii,iRes}),1) - .5 );
    %            % spatial pyramid matching
    %            CC=double(SUM2map{ii,iRes}(:,:));
    %            [CCx CCy]=size(CC);
    %            t1=max(max( CC ));
    %            t2=max(max( CC(1:ceil(CCx/2), 1:ceil(CCy/2)) ));
    %            t3=max(max( CC(1+ceil(CCx/2):end, 1:ceil(CCy/2)) ));
    %            t4=max(max( CC(1:ceil(CCx/2), 1+ceil(CCy/2):CCy) ));
    %            t5=max(max( CC(1+ceil(CCx/2):end, 1+ceil(CCy/2):CCy) )); 
    %            t=[];
    %            for m=1:4
    %                for n=1:4
    %                    t=[t max(max(CC(ceil((m-1)/4*CCx+1):ceil(m/4*CCx), ceil((n-1)/4*CCy+1):ceil(n/4*CCy))))];
    %                end;
    %            end;
    %            tmp_max=[tmp_max; t1 t2 t3 t4 t5 t];
    %        end;
    %        if numResolution>1
    %            tmp_max=max(tmp_max);
    %        end;
    %        L0_positive_sum =[L0_positive_sum tmp_max(1)];
    %        L1_positive_sum =[L1_positive_sum tmp_max(1:5)];
    %        L2_positive_sum =[L2_positive_sum tmp_max];
    %       %mv=max(max(SUM2map{ii,iRes}));
    %        %[ix,iy]=find(SUM2map{ii,iRes}==mv);
    %        %tmpv=[ix(1)-1 iy(1)-1 0 ii-1 mv]';
    %        %tmpActivations=[tmpActivations tmpv];
    %   end
    %    %positive_activations = [positive_activations, [single( str2num(file_name(file_i).name(17:end-10))*ones(1,size(tmpActivations,2))); tmpActivations]];
    %    L0_positive_data=[L0_positive_data; L0_positive_sum];
    %    L1_positive_data=[L1_positive_data; L1_positive_sum];
    %    L2_positive_data=[L2_positive_data; L2_positive_sum];
    %end;
        % add code here
        %tmpActivations = mexc_ComputeMAX2MP( SUM2map, int32(locationPerturbationFraction*partSize/subsampleS2), S2Thres );
        %histV=[histV; hist(tmpActivations(4,:)+1, [1:3*numCluster])];
    
    %positive_activations(2:3,:) = positive_activations(2:3,:) * subsampleS2;
    % add the code here
    %activeMM=[];
    % Gabor basis elements locations
    %for t =1:size(positive_activations,2) % for each activated template (or codeword, or part)
    %    SUM1MAX1mapName = [all_W_fold '/' all_W_n(all_W_c).name '/SUM1MAX1map' 'image' num2str( positive_activations(1,t)) 'scale' num2str(1)];
    %    load(SUM1MAX1mapName, 'SUM1map', 'MAX1map', 'ARGMAX1map','M1RowShift', 'M1ColShift',...
    %                'M1OriShifted', 'J');
        % track Gabor elements of activated templates for this template only
    %    gaborXX = [];
    %    gaborYY = [];
    %    gaborOO = [];
    %    gaborMM = [];
    %    iCluster = ceil( ( positive_activations(5,t) + 1 ) / nTransform );
    %    iTransform = positive_activations(5,t) + 1 - (iCluster-1) * nTransform;
    %    iRes = positive_activations(4,t) + 1;
    %    for j = 1:numElement
    %        gaborX = floor(positive_activations(2,t) + TransformedTemplate{iTransform,iCluster}.selectedRow(j));
    %        gaborY = floor(positive_activations(3,t) + TransformedTemplate{iTransform,iCluster}.selectedCol(j));
    %        gaborO = TransformedTemplate{iTransform,iCluster}.selectedOri(j);
    %        if gaborX > 0 && gaborX <= size(MAX1map{iRes,1},1) && gaborY > 0 && gaborY <= size(MAX1map{iRes,1},2)
    %            trace = ARGMAX1map{iRes,gaborO+1}(gaborX,gaborY) + 1;
    %            dx = M1RowShift{gaborO+1}(trace);
    %            dy = M1ColShift{gaborO+1}(trace);
    %            shiftedo = M1OriShifted{gaborO+1}(trace);
    %            gaborX = floor(.5 + gaborX + single(dx));
    %            gaborY = floor(.5 + gaborY + single(dy));
    %            gaborO = single(shiftedo);
    %        end
    %        gaborXX = [gaborXX;gaborX];
    %        gaborYY = [gaborYY;gaborY];
    %        gaborOO = [gaborOO;gaborO];
    %        if gaborX > 0 && gaborX <= size(MAX1map{iRes,1},1) && gaborY > 0 && gaborY <= size(MAX1map{iRes,1},2)
    %            val = SUM1map{iRes,gaborO+1}(gaborX,gaborY);
    %        else
    %            val = 0;
    %        end
    %        gaborMM = [gaborMM; max(0,sqrt(val)-.2)];
    %    end
    %    activeMM=[activeMM; gaborMM'];
    %end;
    %new_data=[];
    %for tt=1:size(activeMM,1)/numel(SUM2map(:,iRes))
    %    indivi=[];
    %    for jj=1:numel(SUM2map(:,iRes))
    %        indivi=[indivi activeMM((tt-1)*numel(SUM2map(:,iRes))+jj,:)];
    %    end;
    %    new_data=[new_data; indivi];
    %end;
    %save ([all_S_fold '/'  all_W_n(all_W_c).name 'Score'],'L0_positive_data','L1_positive_data','L2_positive_data');
%end; 


%% classification
% L0 SPM
