function [SUM1map,MAX1map,ARGMAX1map,M1RowShift M1ColShift M1OriShifted]=S1M1Func(J,allFilter,fParam)

% compute S1 amd M1 map for input image J0
% Here we assume J0 is one image, with multiple resolutions,
%% Scale factor should be treated outside
numResolution = numel(J);
numOrient = numel(allFilter);
%% Compute SUM1 maps
SUM1map = cell(numResolution,numOrient);
for iRes = 1:numResolution
    SUM1map(iRes,:) = ApplyFilterfftSame(J(iRes), allFilter, fParam.localOrNot, fParam.localHalfx, fParam.localHalfy, fParam.doubleOrNot, fParam.thresholdFactor);  % filter testing image at all resolutions
end
if nargout ==1
    for ii = 1:numel(SUM1map)
        SUM1map{ii} = single( fParam.saturation*(2./(1.+exp(-2.*SUM1map{ii}/fParam.saturation))-1.) );
        SUM1map{ii}(:) = max(0,SUM1map{ii}(:)-fParam.S1softthres);
    end
    return
end
%% Compute MAX1 maps and track maps
subsampleM1 = 1;  % to be safe, please refrain from setting it to be larger than 1
MAX1map = cell(numResolution,numOrient);
ARGMAX1map = cell(numResolution,numOrient);
for iRes = 1:numResolution
    [MAX1map(iRes,:) ARGMAX1map(iRes,:) M1RowShift M1ColShift M1OriShifted] = ...
        mexc_ComputeMAX1( numOrient, SUM1map(iRes,:), fParam.locationShiftLimit,...
        fParam.orientShiftLimit, subsampleM1 );
end

%% sigmoid transformation (modified! was not here before)
for ii = 1:numel(MAX1map)
    MAX1map{ii} = single( fParam.saturation*(2./(1.+exp(-2.*MAX1map{ii}/fParam.saturation))-1.) );
    SUM1map{ii} = single( fParam.saturation*(2./(1.+exp(-2.*SUM1map{ii}/fParam.saturation))-1.) );
end
%% soft thresholding
for ii = 1:numel(SUM1map)
    SUM1map{ii}(:) = max(0,SUM1map{ii}(:)-fParam.S1softthres);
    MAX1map{ii}(:) = max(0,MAX1map{ii}(:)-fParam.S1softthres);
end

%% Save the maps and spaces
%SUM1MAX1mapName = ['working/SUM1MAX1map' 'image' num2str(img) 'scale' num2str(s)];
%save(SUM1MAX1mapName, 'SUM1map', 'MAX1map', 'M1RowShift', 'M1ColShift',...
%	'M1OriShifted', 'ARGMAX1map', 'J');
end

