clear all;
close all;
%% remove existing filefolds
if exist('./document','dir')
    rmdir('./document','s');
end;
if exist('./output','dir')
    rmdir('./output','s');
end;
if exist('./working','dir')
    rmdir('./working','s');
end;
if exist('./test_working','dir')
    rmdir('./test_working','s');
end;
if exist('./score','dir')
    rmdir('./score','s');
end;
%% set path for LIBSVM package
addpath('./liblinear/');
addpath('./liblinear/matlab/');
%% mex-C compilation
mex mexc_ComputeMAX1.cpp
mex mexc_ComputeSUM2.cpp
mex mexc_Histogram.cpp	        % pool histogram from negative images
mex mexc_LocalNormalize.cpp	    % local normalization of type single (float)
mex mexc_SharedSketch.cpp	    % learning by shared sketch algorithm (with data weights)
mex mexc_ComputeMAX2.cpp
mex mexc_ComputeMAX2MP.cpp
mex mexc_TemplateAffineTransform.cpp
mex mexc_CropInstance.cpp
rng('default')
matlabpool open 4
%% parameter settings
ParameterSettings;
%% Learning codebooks from training images
TrainingProcess;
%% Test the learned codebooks on image classification tasks
TestingProcess;
%% Show codebooks, sketches and classification accuracy
GenerateHtml;
%matlabpool close