%% Testing process
close all;
clear all;
%% parameter settings
load ('storedExponentialModel1.mat')
load ('partLocConfig.mat');
load ('PamaTest');
load trainsize;
load testsize;
load trainID;
load testID;
numResolution=numResolutionTest;
numExtend=numExtendTest;
allResolution=allResolutionTest;
originalResolution=originalResolutionTest;
%% load learned model
load ('learning_result.mat');     
S2Templates = cell(numCluster,1);
for cc = 1:numCluster
    S2Templates{cc} = bestS2Templates{cc};
end
TransformedTemplate = cell(nTransform,numCluster);
selectedScale = zeros(1,length(S2Templates{1}.selectedx),'single');
for cc = 1:numCluster
    for iT = 1:nTransform
        templateScaleInd = templateTransform{iT}(1);
        rowScale = templateTransform{iT}(2);
        colScale = templateTransform{iT}(3);
        rotation = templateTransform{iT}(4);
        [tmpSelectedRow tmpSelectedCol tmpSelectedOri tmpSelectedScale] = ...
            mexc_TemplateAffineTransform( templateScaleInd, rowScale,...
            colScale, rotation, S2Templates{cc}.selectedRow, S2Templates{cc}.selectedCol,...
            S2Templates{cc}.selectedOri, selectedScale, numOrient );
        TransformedTemplate{iT,cc}.selectedRow = tmpSelectedRow;
        TransformedTemplate{iT,cc}.selectedCol = tmpSelectedCol;
        TransformedTemplate{iT,cc}.selectedOri = tmpSelectedOri;
        TransformedTemplate{iT,cc}.selectedScale = tmpSelectedScale;
        TransformedTemplate{iT,cc}.selectedLambda = S2Templates{cc}.selectedLambda;
        TransformedTemplate{iT,cc}.selectedLogZ = S2Templates{cc}.selectedLogZ;
    end
end
% prepare for affinity matrix
templateAffinityMatrix = cell( numCluster * nTransform, 1 );
for cc = 1:numCluster
    from = 1; to = nTransform*numCluster;
    for jj = 1:nTransform
        templateAffinityMatrix{jj+(cc-1)*nTransform} = int32((from:to)-1);
    end
end
%% calculate SUM1MAX1
all_W_n=dir(all_W_fold);
%% decoding process
stepSize=2;
halfWinSize=1;
SE=ones(2*halfWinSize+1,2*halfWinSize+1);
Ths=0;
 for all_W_c=3:length(all_W_n)
    sub_sum1max1_file=[all_W_fold '/' all_W_n(all_W_c).name];
    %file_name=dir([sub_sum1max1_file  '/SUM1MAX1map'  '*.mat']);
    load([sub_sum1max1_file '/multipleResolutionImages.mat']);
    numTestImg = numel(IoriginalTest);
    numResolution = size(JoriginalTest,1);
        numTransformedTemplate = nTransform*numCluster;
    updatefParam;
    positive_activations = []; % 3 by N matrix, where N is an unknown large number
    L0_positive_data=zeros(numTestImg,2*numTransformedTemplate);
    L1_positive_data=zeros(numTestImg,6*numTransformedTemplate);
    L2_positive_data=zeros(numTestImg,18*numTransformedTemplate);
    parfor img = 1:numTestImg
        %SUM1MAX1mapName = [sub_sum1max1_file '/' file_name(file_i).name];
        %disp(['decoding image' num2str(file_i)]);
        %load(SUM1MAX1mapName, 'SUM1map', 'MAX1map', 'M1RowShift', 'M1ColShift',...
        %        'M1OriShifted', 'J');
        SUM2map=cell(numTransformedTemplate,numResolution);
        [SUM1map,MAX1map,ARGMAX1map,M1RowShift,M1ColShift,M1OriShifted]=S1M1Func(JoriginalTest(:,img),allFilter,fParam);
        NumsmpX=zeros(numResolution,1);
        NumsmpY=zeros(numResolution,1);
        for iRes = 1:numResolution
            SUM2map(:,iRes) = mexc_ComputeSUM2( numOrient, MAX1map(iRes,:), TransformedTemplate, subsampleS2 );
            Nowhws = halfWinSize*allResolution(iRes);
            Nowsps = stepSize*allResolution(iRes);
            NumsmpX(iRes)=floor((size(SUM2map{1,iRes},1)-2*Nowhws-1)/Nowsps)+1;
            NumsmpY(iRes)=floor((size(SUM2map{1,iRes},2)-2*Nowhws-1)/Nowsps)+1;
        end;
        MINnumX=min(NumsmpX);
        MINnumY=min(NumsmpY);
        POSx=zeros(MINnumX,1);
        POSy=zeros(1,MINnumY);
        posIND=cell(iRes,1);
        sizeI=MINnumX*MINnumY;
        tmpPXV=zeros(MINnumX*MINnumY,1);
        tmpPYV=zeros(MINnumX*MINnumY,1);
        for iRes = 1:numResolution
            Nowhws = halfWinSize*allResolution(iRes);
            Nowsps = stepSize*allResolution(iRes);
            POSx = round(((1:MINnumX)'-1)*Nowsps+Nowhws +1);
            POSy = round(((1:MINnumY)-1)*Nowsps+Nowhws +1);
            tmpPXV=reshape(repmat(POSx,1,length(POSy)),sizeI,1);
            tmpPYV=reshape(repmat(POSy,length(POSx),1),sizeI,1);
            posIND{iRes}=sub2ind(size(SUM2map{1,iRes}), tmpPXV, tmpPYV);
        end;
        
        tmpMAXSUM2=cell(numel(SUM2map(:,1)),numResolution);
        %sumSUM2=zeros(MINnumX,MINnumY);
        for ii = 1:numel(SUM2map(:,1))
            for iRes = 1:numResolution
                tmpMAXSUM2{ii,iRes}=zeros(MINnumX,MINnumY);
                lcMax=imdilate(SUM2map{ii,iRes},SE);
                tmpMAXSUM2{ii,iRes}=reshape(lcMax(posIND{iRes}), MINnumX, MINnumY);
                inds=find(tmpMAXSUM2{ii,iRes}(:)<Ths);
                tmpMAXSUM2{ii,iRes}(inds)=Ths;
                %sumSUM2=sumSUM2+tmpMAXSUM2{ii,iRes};
            end;
        end;
        % normalized
        %for ii = 1:numel(SUM2map(:,1))
        %    for iRes = 1:numResolution
        %        tmpMAXSUM2{ii,iRes}=tmpMAXSUM2{ii,iRes}./sumSUM2;
        %    end;
        %end;
        
        %SUM2map = mexc_ComputeSUM2( numOrient, MAX1map, TransformedTemplate, subsampleS2 );
        % random perturbation (to break ties arbitrarily for MAX2)
        L0_positive_sum=zeros(1,2*numTransformedTemplate);
        L1_positive_sum=zeros(1,6*numTransformedTemplate);
        L2_positive_sum=zeros(1,18*numTransformedTemplate);
        %tmpActivations=[];
        for ii = 1:numel(SUM2map(:,iRes))
            tmp_max=[];
            for iRes=1:numResolution
                %SUM2map{ii,iRes}(:) = SUM2map{ii,iRes}(:) + 1e-3 * ( rand(numel(SUM2map{ii,iRes}),1) - .5 );
                % spatial pyramid matching
                CC=tmpMAXSUM2{ii,iRes};
                [CCx CCy]=size(CC);
                t1=[max(max( CC )) mean(mean(CC))];
                t2=max(max( CC(1:ceil(CCx/2), 1:ceil(CCy/2)) ));
                t3=max(max( CC(1+ceil(CCx/2):end, 1:ceil(CCy/2)) ));
                t4=max(max( CC(1:ceil(CCx/2), 1+ceil(CCy/2):CCy) ));
                t5=max(max( CC(1+ceil(CCx/2):end, 1+ceil(CCy/2):CCy) )); 
                t=[t1 t2 t3 t4 t5];
                %for m=1:3
                %    for n=1:3
                %        t=[t max(max(CC(ceil((m-1)/3*CCx+1):ceil(m/3*CCx), ceil((n-1)/3*CCy+1):ceil(n/3*CCy))))];
                %    end;
                %end;
                %t=[t max( max( CC(1:ceil(CCx/3),:) ) )   max( max( CC(1+ceil(CCx/3):ceil(2*CCx/3),:) ) )  max( max( CC(1+ceil(2*CCx/3):end,:) ) )];
                %t=[t max( max( CC( 1+ceil(1*CCx/4):ceil(3*CCx/4),1+ceil(1*CCy/4):ceil(3*CCy/4) )))];
                t2=mean(mean( CC(1:ceil(CCx/2), 1:ceil(CCy/2)) ));
                t3=mean(mean( CC(1+ceil(CCx/2):end, 1:ceil(CCy/2)) ));
                t4=mean(mean( CC(1:ceil(CCx/2), 1+ceil(CCy/2):CCy) ));
                t5=mean(mean( CC(1+ceil(CCx/2):end, 1+ceil(CCy/2):CCy) )); 
                t=[t t2 t3 t4 t5];
                
                t2=mean(mean( CC(1:ceil(CCx/2), :) ));
                t3=mean(mean( CC(1+ceil(CCx/2):end, :) ));
                t4=mean(mean( CC(:, 1:ceil(CCy/2)) ));
                t5=mean(mean( CC(:, 1+ceil(CCy/2):CCy) )); 
                t=[t t2 t3 t4 t5];
                
                t2=max(max( CC(1:ceil(CCx/2), :) ));
                t3=max(max( CC(1+ceil(CCx/2):end, :) ));
                t4=max(max( CC(:, 1:ceil(CCy/2)) ));
                t5=max(max( CC(:, 1+ceil(CCy/2):CCy) )); 
                t=[t t2 t3 t4 t5];
                
                tmp_max = [tmp_max; t];
            end;
            tmp=max(tmp_max);
            L0_positive_sum((ii-1)*2+1:ii*2)=tmp(1:2);
            L1_positive_sum( (ii-1)*6+1:ii*6)= tmp(1:6);
            L2_positive_sum( (ii-1)*18+1:ii*18)= tmp;
            
            %mv=max(max(SUM2map{ii,iRes}));
            %[ix,iy]=find(SUM2map{ii,iRes}==mv);
            %tmpv=[ix(1)-1 iy(1)-1 0 ii-1 mv]';
            %tmpActivations=[tmpActivations tmpv];
        end
        %positive_activations = [positive_activations, [single( str2num(file_name(file_i).name(17:end-10))*ones(1,size(tmpActivations,2))); tmpActivations]];
        L0_positive_data(img,:)=L0_positive_sum;
        L1_positive_data(img,:)=L1_positive_sum;
        L2_positive_data(img,:)=L2_positive_sum;
        % add code here
        %tmpActivations = mexc_ComputeMAX2MP( SUM2map, int32(locationPerturbationFraction*partSize/subsampleS2), S2Thres );
        %histV=[histV; hist(tmpActivations(4,:)+1, [1:3*numCluster])];
    end;
    save ([all_S_fold '/'  all_W_n(all_W_c).name 'Score'],'L0_positive_data','L1_positive_data','L2_positive_data');
end; 


%% classification
trainsize=15;
thre=0;
all_S_fold='./score';
score=dir(all_S_fold);
traindata.x=[];
traindata.y=[];
testdata.x =[];
testdata.y =[];
for i=3:length(score)
    load ([all_S_fold '/' score(i).name]);
    traindata.x=[traindata.x; L2_positive_data(1:trainsize,:)];
    traindata.y=[traindata.y; ones(trainsize,1)*(i-2)];
    testdata.x=[testdata.x; L2_positive_data(trainsize+1:end,:)];
    testdata.y=[testdata.y; ones(size(L2_positive_data,1)-trainsize,1)*(i-2)];
end;
% normalized them to [0 1]
T=[traindata.x;testdata.x];
ind=find(T(:)<thre);
T(ind)=thre;
trs=size(traindata.x,1);
for ii=1:size(T,2)
    minv=min(T(1:trs,ii));
    maxv=max(T(1:trs,ii));
    if maxv-minv>0.0
    T(:,ii)=(T(:,ii)-minv)/(maxv-minv);
    else
    T(:,ii)=zeros(size(T,1),1);
    end;
end;

traindata.x=T(1:trs,:);
testdata.x=T(trs+1:end,:);

C=2.0; 
para=['-s 0 -c ' num2str(C)]; 
model = train(traindata.y,sparse(double (traindata.x)),para);
[L0_label,accuracy_L0]=predict(testdata.y, sparse(double(testdata.x)), model);

for ii=1:max(testdata.y)
    ind=find(testdata.y==ii);
    acc(ii)=length(find(testdata.y(ind)==L0_label(ind)))/length(ind);
end;